library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.HermesPackage.all;

entity NOC is
port(
	clock : in std_logic;
	reset : in std_logic;
	rxLocal : in  regNrot;
	data_inLocal : in  arrayNrot_regflit;
	ack_rxLocal : out regNrot;
	txLocal : out regNrot;
	data_outLocal : out arrayNrot_regflit;
	ack_txLocal : in  regNrot);
end NOC;

architecture NOC of NOC is

	signal rxN0000, rxN0100, rxN0200, rxN0300, rxN0400 : regNport;
	signal data_inN0000, data_inN0100, data_inN0200, data_inN0300, data_inN0400 : arrayNport_regflit;
	signal ack_rxN0000, ack_rxN0100, ack_rxN0200, ack_rxN0300, ack_rxN0400 : regNport;
	signal txN0000, txN0100, txN0200, txN0300, txN0400 : regNport;
	signal data_outN0000, data_outN0100, data_outN0200, data_outN0300, data_outN0400 : arrayNport_regflit;
	signal ack_txN0000, ack_txN0100, ack_txN0200, ack_txN0300, ack_txN0400 : regNport;
	signal rxN0001, rxN0101, rxN0201, rxN0301, rxN0401 : regNport;
	signal data_inN0001, data_inN0101, data_inN0201, data_inN0301, data_inN0401 : arrayNport_regflit;
	signal ack_rxN0001, ack_rxN0101, ack_rxN0201, ack_rxN0301, ack_rxN0401 : regNport;
	signal txN0001, txN0101, txN0201, txN0301, txN0401 : regNport;
	signal data_outN0001, data_outN0101, data_outN0201, data_outN0301, data_outN0401 : arrayNport_regflit;
	signal ack_txN0001, ack_txN0101, ack_txN0201, ack_txN0301, ack_txN0401 : regNport;
	signal rxN0002, rxN0102, rxN0202, rxN0302, rxN0402 : regNport;
	signal data_inN0002, data_inN0102, data_inN0202, data_inN0302, data_inN0402 : arrayNport_regflit;
	signal ack_rxN0002, ack_rxN0102, ack_rxN0202, ack_rxN0302, ack_rxN0402 : regNport;
	signal txN0002, txN0102, txN0202, txN0302, txN0402 : regNport;
	signal data_outN0002, data_outN0102, data_outN0202, data_outN0302, data_outN0402 : arrayNport_regflit;
	signal ack_txN0002, ack_txN0102, ack_txN0202, ack_txN0302, ack_txN0402 : regNport;
	signal rxN0003, rxN0103, rxN0203, rxN0303, rxN0403 : regNport;
	signal data_inN0003, data_inN0103, data_inN0203, data_inN0303, data_inN0403 : arrayNport_regflit;
	signal ack_rxN0003, ack_rxN0103, ack_rxN0203, ack_rxN0303, ack_rxN0403 : regNport;
	signal txN0003, txN0103, txN0203, txN0303, txN0403 : regNport;
	signal data_outN0003, data_outN0103, data_outN0203, data_outN0303, data_outN0403 : arrayNport_regflit;
	signal ack_txN0003, ack_txN0103, ack_txN0203, ack_txN0303, ack_txN0403 : regNport;
	signal rxN0004, rxN0104, rxN0204, rxN0304, rxN0404 : regNport;
	signal data_inN0004, data_inN0104, data_inN0204, data_inN0304, data_inN0404 : arrayNport_regflit;
	signal ack_rxN0004, ack_rxN0104, ack_rxN0204, ack_rxN0304, ack_rxN0404 : regNport;
	signal txN0004, txN0104, txN0204, txN0304, txN0404 : regNport;
	signal data_outN0004, data_outN0104, data_outN0204, data_outN0304, data_outN0404 : arrayNport_regflit;
	signal ack_txN0004, ack_txN0104, ack_txN0204, ack_txN0304, ack_txN0404 : regNport;
begin

	Chave0000 : Entity work.ChaveTL(ChaveTL)
	generic map( address => ADDRESSN0000 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0000,
		data_in => data_inN0000,
		ack_rx => ack_rxN0000,
		tx => txN0000,
		data_out => data_outN0000,
		ack_tx => ack_txN0000
	);

	Chave0100 : Entity work.ChaveTC(ChaveTC)
	generic map( address => ADDRESSN0100 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0100,
		data_in => data_inN0100,
		ack_rx => ack_rxN0100,
		tx => txN0100,
		data_out => data_outN0100,
		ack_tx => ack_txN0100
	);

	Chave0200 : Entity work.ChaveTC(ChaveTC)
	generic map( address => ADDRESSN0200 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0200,
		data_in => data_inN0200,
		ack_rx => ack_rxN0200,
		tx => txN0200,
		data_out => data_outN0200,
		ack_tx => ack_txN0200
	);

	Chave0300 : Entity work.ChaveTC(ChaveTC)
	generic map( address => ADDRESSN0300 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0300,
		data_in => data_inN0300,
		ack_rx => ack_rxN0300,
		tx => txN0300,
		data_out => data_outN0300,
		ack_tx => ack_txN0300
	);

	Chave0400 : Entity work.ChaveTR(ChaveTR)
	generic map( address => ADDRESSN0400 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0400,
		data_in => data_inN0400,
		ack_rx => ack_rxN0400,
		tx => txN0400,
		data_out => data_outN0400,
		ack_tx => ack_txN0400
	);

	Chave0001 : Entity work.ChaveCL(ChaveCL)
	generic map( address => ADDRESSN0001 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0001,
		data_in => data_inN0001,
		ack_rx => ack_rxN0001,
		tx => txN0001,
		data_out => data_outN0001,
		ack_tx => ack_txN0001
	);

	Chave0101 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0101 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0101,
		data_in => data_inN0101,
		ack_rx => ack_rxN0101,
		tx => txN0101,
		data_out => data_outN0101,
		ack_tx => ack_txN0101
	);

	Chave0201 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0201 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0201,
		data_in => data_inN0201,
		ack_rx => ack_rxN0201,
		tx => txN0201,
		data_out => data_outN0201,
		ack_tx => ack_txN0201
	);

	Chave0301 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0301 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0301,
		data_in => data_inN0301,
		ack_rx => ack_rxN0301,
		tx => txN0301,
		data_out => data_outN0301,
		ack_tx => ack_txN0301
	);

	Chave0401 : Entity work.ChaveCR(ChaveCR)
	generic map( address => ADDRESSN0401 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0401,
		data_in => data_inN0401,
		ack_rx => ack_rxN0401,
		tx => txN0401,
		data_out => data_outN0401,
		ack_tx => ack_txN0401
	);

	Chave0002 : Entity work.ChaveCL(ChaveCL)
	generic map( address => ADDRESSN0002 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0002,
		data_in => data_inN0002,
		ack_rx => ack_rxN0002,
		tx => txN0002,
		data_out => data_outN0002,
		ack_tx => ack_txN0002
	);

	Chave0102 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0102 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0102,
		data_in => data_inN0102,
		ack_rx => ack_rxN0102,
		tx => txN0102,
		data_out => data_outN0102,
		ack_tx => ack_txN0102
	);

	Chave0202 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0202 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0202,
		data_in => data_inN0202,
		ack_rx => ack_rxN0202,
		tx => txN0202,
		data_out => data_outN0202,
		ack_tx => ack_txN0202
	);

	Chave0302 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0302 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0302,
		data_in => data_inN0302,
		ack_rx => ack_rxN0302,
		tx => txN0302,
		data_out => data_outN0302,
		ack_tx => ack_txN0302
	);

	Chave0402 : Entity work.ChaveCR(ChaveCR)
	generic map( address => ADDRESSN0402 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0402,
		data_in => data_inN0402,
		ack_rx => ack_rxN0402,
		tx => txN0402,
		data_out => data_outN0402,
		ack_tx => ack_txN0402
	);

	Chave0003 : Entity work.ChaveCL(ChaveCL)
	generic map( address => ADDRESSN0003 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0003,
		data_in => data_inN0003,
		ack_rx => ack_rxN0003,
		tx => txN0003,
		data_out => data_outN0003,
		ack_tx => ack_txN0003
	);

	Chave0103 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0103 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0103,
		data_in => data_inN0103,
		ack_rx => ack_rxN0103,
		tx => txN0103,
		data_out => data_outN0103,
		ack_tx => ack_txN0103
	);

	Chave0203 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0203 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0203,
		data_in => data_inN0203,
		ack_rx => ack_rxN0203,
		tx => txN0203,
		data_out => data_outN0203,
		ack_tx => ack_txN0203
	);

	Chave0303 : Entity work.ChaveCC(ChaveCC)
	generic map( address => ADDRESSN0303 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0303,
		data_in => data_inN0303,
		ack_rx => ack_rxN0303,
		tx => txN0303,
		data_out => data_outN0303,
		ack_tx => ack_txN0303
	);

	Chave0403 : Entity work.ChaveCR(ChaveCR)
	generic map( address => ADDRESSN0403 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0403,
		data_in => data_inN0403,
		ack_rx => ack_rxN0403,
		tx => txN0403,
		data_out => data_outN0403,
		ack_tx => ack_txN0403
	);

	Chave0004 : Entity work.ChaveBL(ChaveBL)
	generic map( address => ADDRESSN0004 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0004,
		data_in => data_inN0004,
		ack_rx => ack_rxN0004,
		tx => txN0004,
		data_out => data_outN0004,
		ack_tx => ack_txN0004
	);

	Chave0104 : Entity work.ChaveBC(ChaveBC)
	generic map( address => ADDRESSN0104 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0104,
		data_in => data_inN0104,
		ack_rx => ack_rxN0104,
		tx => txN0104,
		data_out => data_outN0104,
		ack_tx => ack_txN0104
	);

	Chave0204 : Entity work.ChaveBC(ChaveBC)
	generic map( address => ADDRESSN0204 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0204,
		data_in => data_inN0204,
		ack_rx => ack_rxN0204,
		tx => txN0204,
		data_out => data_outN0204,
		ack_tx => ack_txN0204
	);

	Chave0304 : Entity work.ChaveBC(ChaveBC)
	generic map( address => ADDRESSN0304 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0304,
		data_in => data_inN0304,
		ack_rx => ack_rxN0304,
		tx => txN0304,
		data_out => data_outN0304,
		ack_tx => ack_txN0304
	);

	Chave0404 : Entity work.ChaveBR(ChaveBR)
	generic map( address => ADDRESSN0404 )
	port map(
		clock => clock,
		reset => reset,
		rx => rxN0404,
		data_in => data_inN0404,
		ack_rx => ack_rxN0404,
		tx => txN0404,
		data_out => data_outN0404,
		ack_tx => ack_txN0404
	);

	-- entradas do roteador0000
	data_inN0000(0)<=data_outN0100(1);
	rxN0000(0)<=txN0100(1);
	ack_txN0000(0)<=ack_rxN0100(1);
	data_inN0000(1)<=(others=>'0');
	rxN0000(1)<='0';
	ack_txN0000(1)<='0';
	data_inN0000(2)<=(others=>'0');
	rxN0000(2)<='0';
	ack_txN0000(2)<='0';
	data_inN0000(3)<=data_outN0001(2);
	rxN0000(3)<=txN0001(2);
	ack_txN0000(3)<=ack_rxN0001(2);
	data_inN0000(4)<=data_inLocal(N0000);
	rxN0000(4)<=rxLocal(N0000);
	ack_txN0000(4)<=ack_txLocal(N0000);
	ack_rxLocal(N0000)<=ack_rxN0000(4);
	data_outLocal(N0000)<=data_outN0000(4);
	txLocal(N0000)<=txN0000(4);

	-- entradas do roteador0100
	data_inN0100(0)<=data_outN0200(1);
	rxN0100(0)<=txN0200(1);
	ack_txN0100(0)<=ack_rxN0200(1);
	data_inN0100(1)<=data_outN0000(0);
	rxN0100(1)<=txN0000(0);
	ack_txN0100(1)<=ack_rxN0000(0);
	data_inN0100(2)<=(others=>'0');
	rxN0100(2)<='0';
	ack_txN0100(2)<='0';
	data_inN0100(3)<=data_outN0101(2);
	rxN0100(3)<=txN0101(2);
	ack_txN0100(3)<=ack_rxN0101(2);
	data_inN0100(4)<=data_inLocal(N0100);
	rxN0100(4)<=rxLocal(N0100);
	ack_txN0100(4)<=ack_txLocal(N0100);
	ack_rxLocal(N0100)<=ack_rxN0100(4);
	data_outLocal(N0100)<=data_outN0100(4);
	txLocal(N0100)<=txN0100(4);

	-- entradas do roteador0200
	data_inN0200(0)<=data_outN0300(1);
	rxN0200(0)<=txN0300(1);
	ack_txN0200(0)<=ack_rxN0300(1);
	data_inN0200(1)<=data_outN0100(0);
	rxN0200(1)<=txN0100(0);
	ack_txN0200(1)<=ack_rxN0100(0);
	data_inN0200(2)<=(others=>'0');
	rxN0200(2)<='0';
	ack_txN0200(2)<='0';
	data_inN0200(3)<=data_outN0201(2);
	rxN0200(3)<=txN0201(2);
	ack_txN0200(3)<=ack_rxN0201(2);
	data_inN0200(4)<=data_inLocal(N0200);
	rxN0200(4)<=rxLocal(N0200);
	ack_txN0200(4)<=ack_txLocal(N0200);
	ack_rxLocal(N0200)<=ack_rxN0200(4);
	data_outLocal(N0200)<=data_outN0200(4);
	txLocal(N0200)<=txN0200(4);

	-- entradas do roteador0300
	data_inN0300(0)<=data_outN0400(1);
	rxN0300(0)<=txN0400(1);
	ack_txN0300(0)<=ack_rxN0400(1);
	data_inN0300(1)<=data_outN0200(0);
	rxN0300(1)<=txN0200(0);
	ack_txN0300(1)<=ack_rxN0200(0);
	data_inN0300(2)<=(others=>'0');
	rxN0300(2)<='0';
	ack_txN0300(2)<='0';
	data_inN0300(3)<=data_outN0301(2);
	rxN0300(3)<=txN0301(2);
	ack_txN0300(3)<=ack_rxN0301(2);
	data_inN0300(4)<=data_inLocal(N0300);
	rxN0300(4)<=rxLocal(N0300);
	ack_txN0300(4)<=ack_txLocal(N0300);
	ack_rxLocal(N0300)<=ack_rxN0300(4);
	data_outLocal(N0300)<=data_outN0300(4);
	txLocal(N0300)<=txN0300(4);

	-- entradas do roteador0400
	data_inN0400(0)<=(others=>'0');
	rxN0400(0)<='0';
	ack_txN0400(0)<='0';
	data_inN0400(1)<=data_outN0300(0);
	rxN0400(1)<=txN0300(0);
	ack_txN0400(1)<=ack_rxN0300(0);
	data_inN0400(2)<=(others=>'0');
	rxN0400(2)<='0';
	ack_txN0400(2)<='0';
	data_inN0400(3)<=data_outN0401(2);
	rxN0400(3)<=txN0401(2);
	ack_txN0400(3)<=ack_rxN0401(2);
	data_inN0400(4)<=data_inLocal(N0400);
	rxN0400(4)<=rxLocal(N0400);
	ack_txN0400(4)<=ack_txLocal(N0400);
	ack_rxLocal(N0400)<=ack_rxN0400(4);
	data_outLocal(N0400)<=data_outN0400(4);
	txLocal(N0400)<=txN0400(4);

	-- entradas do roteador0001
	data_inN0001(0)<=data_outN0101(1);
	rxN0001(0)<=txN0101(1);
	ack_txN0001(0)<=ack_rxN0101(1);
	data_inN0001(1)<=(others=>'0');
	rxN0001(1)<='0';
	ack_txN0001(1)<='0';
	data_inN0001(2)<=data_outN0000(3);
	rxN0001(2)<=txN0000(3);
	ack_txN0001(2)<=ack_rxN0000(3);
	data_inN0001(3)<=data_outN0002(2);
	rxN0001(3)<=txN0002(2);
	ack_txN0001(3)<=ack_rxN0002(2);
	data_inN0001(4)<=data_inLocal(N0001);
	rxN0001(4)<=rxLocal(N0001);
	ack_txN0001(4)<=ack_txLocal(N0001);
	ack_rxLocal(N0001)<=ack_rxN0001(4);
	data_outLocal(N0001)<=data_outN0001(4);
	txLocal(N0001)<=txN0001(4);

	-- entradas do roteador0101
	data_inN0101(0)<=data_outN0201(1);
	rxN0101(0)<=txN0201(1);
	ack_txN0101(0)<=ack_rxN0201(1);
	data_inN0101(1)<=data_outN0001(0);
	rxN0101(1)<=txN0001(0);
	ack_txN0101(1)<=ack_rxN0001(0);
	data_inN0101(2)<=data_outN0100(3);
	rxN0101(2)<=txN0100(3);
	ack_txN0101(2)<=ack_rxN0100(3);
	data_inN0101(3)<=data_outN0102(2);
	rxN0101(3)<=txN0102(2);
	ack_txN0101(3)<=ack_rxN0102(2);
	data_inN0101(4)<=data_inLocal(N0101);
	rxN0101(4)<=rxLocal(N0101);
	ack_txN0101(4)<=ack_txLocal(N0101);
	ack_rxLocal(N0101)<=ack_rxN0101(4);
	data_outLocal(N0101)<=data_outN0101(4);
	txLocal(N0101)<=txN0101(4);

	-- entradas do roteador0201
	data_inN0201(0)<=data_outN0301(1);
	rxN0201(0)<=txN0301(1);
	ack_txN0201(0)<=ack_rxN0301(1);
	data_inN0201(1)<=data_outN0101(0);
	rxN0201(1)<=txN0101(0);
	ack_txN0201(1)<=ack_rxN0101(0);
	data_inN0201(2)<=data_outN0200(3);
	rxN0201(2)<=txN0200(3);
	ack_txN0201(2)<=ack_rxN0200(3);
	data_inN0201(3)<=data_outN0202(2);
	rxN0201(3)<=txN0202(2);
	ack_txN0201(3)<=ack_rxN0202(2);
	data_inN0201(4)<=data_inLocal(N0201);
	rxN0201(4)<=rxLocal(N0201);
	ack_txN0201(4)<=ack_txLocal(N0201);
	ack_rxLocal(N0201)<=ack_rxN0201(4);
	data_outLocal(N0201)<=data_outN0201(4);
	txLocal(N0201)<=txN0201(4);

	-- entradas do roteador0301
	data_inN0301(0)<=data_outN0401(1);
	rxN0301(0)<=txN0401(1);
	ack_txN0301(0)<=ack_rxN0401(1);
	data_inN0301(1)<=data_outN0201(0);
	rxN0301(1)<=txN0201(0);
	ack_txN0301(1)<=ack_rxN0201(0);
	data_inN0301(2)<=data_outN0300(3);
	rxN0301(2)<=txN0300(3);
	ack_txN0301(2)<=ack_rxN0300(3);
	data_inN0301(3)<=data_outN0302(2);
	rxN0301(3)<=txN0302(2);
	ack_txN0301(3)<=ack_rxN0302(2);
	data_inN0301(4)<=data_inLocal(N0301);
	rxN0301(4)<=rxLocal(N0301);
	ack_txN0301(4)<=ack_txLocal(N0301);
	ack_rxLocal(N0301)<=ack_rxN0301(4);
	data_outLocal(N0301)<=data_outN0301(4);
	txLocal(N0301)<=txN0301(4);

	-- entradas do roteador0401
	data_inN0401(0)<=(others=>'0');
	rxN0401(0)<='0';
	ack_txN0401(0)<='0';
	data_inN0401(1)<=data_outN0301(0);
	rxN0401(1)<=txN0301(0);
	ack_txN0401(1)<=ack_rxN0301(0);
	data_inN0401(2)<=data_outN0400(3);
	rxN0401(2)<=txN0400(3);
	ack_txN0401(2)<=ack_rxN0400(3);
	data_inN0401(3)<=data_outN0402(2);
	rxN0401(3)<=txN0402(2);
	ack_txN0401(3)<=ack_rxN0402(2);
	data_inN0401(4)<=data_inLocal(N0401);
	rxN0401(4)<=rxLocal(N0401);
	ack_txN0401(4)<=ack_txLocal(N0401);
	ack_rxLocal(N0401)<=ack_rxN0401(4);
	data_outLocal(N0401)<=data_outN0401(4);
	txLocal(N0401)<=txN0401(4);

	-- entradas do roteador0002
	data_inN0002(0)<=data_outN0102(1);
	rxN0002(0)<=txN0102(1);
	ack_txN0002(0)<=ack_rxN0102(1);
	data_inN0002(1)<=(others=>'0');
	rxN0002(1)<='0';
	ack_txN0002(1)<='0';
	data_inN0002(2)<=data_outN0001(3);
	rxN0002(2)<=txN0001(3);
	ack_txN0002(2)<=ack_rxN0001(3);
	data_inN0002(3)<=data_outN0003(2);
	rxN0002(3)<=txN0003(2);
	ack_txN0002(3)<=ack_rxN0003(2);
	data_inN0002(4)<=data_inLocal(N0002);
	rxN0002(4)<=rxLocal(N0002);
	ack_txN0002(4)<=ack_txLocal(N0002);
	ack_rxLocal(N0002)<=ack_rxN0002(4);
	data_outLocal(N0002)<=data_outN0002(4);
	txLocal(N0002)<=txN0002(4);

	-- entradas do roteador0102
	data_inN0102(0)<=data_outN0202(1);
	rxN0102(0)<=txN0202(1);
	ack_txN0102(0)<=ack_rxN0202(1);
	data_inN0102(1)<=data_outN0002(0);
	rxN0102(1)<=txN0002(0);
	ack_txN0102(1)<=ack_rxN0002(0);
	data_inN0102(2)<=data_outN0101(3);
	rxN0102(2)<=txN0101(3);
	ack_txN0102(2)<=ack_rxN0101(3);
	data_inN0102(3)<=data_outN0103(2);
	rxN0102(3)<=txN0103(2);
	ack_txN0102(3)<=ack_rxN0103(2);
	data_inN0102(4)<=data_inLocal(N0102);
	rxN0102(4)<=rxLocal(N0102);
	ack_txN0102(4)<=ack_txLocal(N0102);
	ack_rxLocal(N0102)<=ack_rxN0102(4);
	data_outLocal(N0102)<=data_outN0102(4);
	txLocal(N0102)<=txN0102(4);

	-- entradas do roteador0202
	data_inN0202(0)<=data_outN0302(1);
	rxN0202(0)<=txN0302(1);
	ack_txN0202(0)<=ack_rxN0302(1);
	data_inN0202(1)<=data_outN0102(0);
	rxN0202(1)<=txN0102(0);
	ack_txN0202(1)<=ack_rxN0102(0);
	data_inN0202(2)<=data_outN0201(3);
	rxN0202(2)<=txN0201(3);
	ack_txN0202(2)<=ack_rxN0201(3);
	data_inN0202(3)<=data_outN0203(2);
	rxN0202(3)<=txN0203(2);
	ack_txN0202(3)<=ack_rxN0203(2);
	data_inN0202(4)<=data_inLocal(N0202);
	rxN0202(4)<=rxLocal(N0202);
	ack_txN0202(4)<=ack_txLocal(N0202);
	ack_rxLocal(N0202)<=ack_rxN0202(4);
	data_outLocal(N0202)<=data_outN0202(4);
	txLocal(N0202)<=txN0202(4);

	-- entradas do roteador0302
	data_inN0302(0)<=data_outN0402(1);
	rxN0302(0)<=txN0402(1);
	ack_txN0302(0)<=ack_rxN0402(1);
	data_inN0302(1)<=data_outN0202(0);
	rxN0302(1)<=txN0202(0);
	ack_txN0302(1)<=ack_rxN0202(0);
	data_inN0302(2)<=data_outN0301(3);
	rxN0302(2)<=txN0301(3);
	ack_txN0302(2)<=ack_rxN0301(3);
	data_inN0302(3)<=data_outN0303(2);
	rxN0302(3)<=txN0303(2);
	ack_txN0302(3)<=ack_rxN0303(2);
	data_inN0302(4)<=data_inLocal(N0302);
	rxN0302(4)<=rxLocal(N0302);
	ack_txN0302(4)<=ack_txLocal(N0302);
	ack_rxLocal(N0302)<=ack_rxN0302(4);
	data_outLocal(N0302)<=data_outN0302(4);
	txLocal(N0302)<=txN0302(4);

	-- entradas do roteador0402
	data_inN0402(0)<=(others=>'0');
	rxN0402(0)<='0';
	ack_txN0402(0)<='0';
	data_inN0402(1)<=data_outN0302(0);
	rxN0402(1)<=txN0302(0);
	ack_txN0402(1)<=ack_rxN0302(0);
	data_inN0402(2)<=data_outN0401(3);
	rxN0402(2)<=txN0401(3);
	ack_txN0402(2)<=ack_rxN0401(3);
	data_inN0402(3)<=data_outN0403(2);
	rxN0402(3)<=txN0403(2);
	ack_txN0402(3)<=ack_rxN0403(2);
	data_inN0402(4)<=data_inLocal(N0402);
	rxN0402(4)<=rxLocal(N0402);
	ack_txN0402(4)<=ack_txLocal(N0402);
	ack_rxLocal(N0402)<=ack_rxN0402(4);
	data_outLocal(N0402)<=data_outN0402(4);
	txLocal(N0402)<=txN0402(4);

	-- entradas do roteador0003
	data_inN0003(0)<=data_outN0103(1);
	rxN0003(0)<=txN0103(1);
	ack_txN0003(0)<=ack_rxN0103(1);
	data_inN0003(1)<=(others=>'0');
	rxN0003(1)<='0';
	ack_txN0003(1)<='0';
	data_inN0003(2)<=data_outN0002(3);
	rxN0003(2)<=txN0002(3);
	ack_txN0003(2)<=ack_rxN0002(3);
	data_inN0003(3)<=data_outN0004(2);
	rxN0003(3)<=txN0004(2);
	ack_txN0003(3)<=ack_rxN0004(2);
	data_inN0003(4)<=data_inLocal(N0003);
	rxN0003(4)<=rxLocal(N0003);
	ack_txN0003(4)<=ack_txLocal(N0003);
	ack_rxLocal(N0003)<=ack_rxN0003(4);
	data_outLocal(N0003)<=data_outN0003(4);
	txLocal(N0003)<=txN0003(4);

	-- entradas do roteador0103
	data_inN0103(0)<=data_outN0203(1);
	rxN0103(0)<=txN0203(1);
	ack_txN0103(0)<=ack_rxN0203(1);
	data_inN0103(1)<=data_outN0003(0);
	rxN0103(1)<=txN0003(0);
	ack_txN0103(1)<=ack_rxN0003(0);
	data_inN0103(2)<=data_outN0102(3);
	rxN0103(2)<=txN0102(3);
	ack_txN0103(2)<=ack_rxN0102(3);
	data_inN0103(3)<=data_outN0104(2);
	rxN0103(3)<=txN0104(2);
	ack_txN0103(3)<=ack_rxN0104(2);
	data_inN0103(4)<=data_inLocal(N0103);
	rxN0103(4)<=rxLocal(N0103);
	ack_txN0103(4)<=ack_txLocal(N0103);
	ack_rxLocal(N0103)<=ack_rxN0103(4);
	data_outLocal(N0103)<=data_outN0103(4);
	txLocal(N0103)<=txN0103(4);

	-- entradas do roteador0203
	data_inN0203(0)<=data_outN0303(1);
	rxN0203(0)<=txN0303(1);
	ack_txN0203(0)<=ack_rxN0303(1);
	data_inN0203(1)<=data_outN0103(0);
	rxN0203(1)<=txN0103(0);
	ack_txN0203(1)<=ack_rxN0103(0);
	data_inN0203(2)<=data_outN0202(3);
	rxN0203(2)<=txN0202(3);
	ack_txN0203(2)<=ack_rxN0202(3);
	data_inN0203(3)<=data_outN0204(2);
	rxN0203(3)<=txN0204(2);
	ack_txN0203(3)<=ack_rxN0204(2);
	data_inN0203(4)<=data_inLocal(N0203);
	rxN0203(4)<=rxLocal(N0203);
	ack_txN0203(4)<=ack_txLocal(N0203);
	ack_rxLocal(N0203)<=ack_rxN0203(4);
	data_outLocal(N0203)<=data_outN0203(4);
	txLocal(N0203)<=txN0203(4);

	-- entradas do roteador0303
	data_inN0303(0)<=data_outN0403(1);
	rxN0303(0)<=txN0403(1);
	ack_txN0303(0)<=ack_rxN0403(1);
	data_inN0303(1)<=data_outN0203(0);
	rxN0303(1)<=txN0203(0);
	ack_txN0303(1)<=ack_rxN0203(0);
	data_inN0303(2)<=data_outN0302(3);
	rxN0303(2)<=txN0302(3);
	ack_txN0303(2)<=ack_rxN0302(3);
	data_inN0303(3)<=data_outN0304(2);
	rxN0303(3)<=txN0304(2);
	ack_txN0303(3)<=ack_rxN0304(2);
	data_inN0303(4)<=data_inLocal(N0303);
	rxN0303(4)<=rxLocal(N0303);
	ack_txN0303(4)<=ack_txLocal(N0303);
	ack_rxLocal(N0303)<=ack_rxN0303(4);
	data_outLocal(N0303)<=data_outN0303(4);
	txLocal(N0303)<=txN0303(4);

	-- entradas do roteador0403
	data_inN0403(0)<=(others=>'0');
	rxN0403(0)<='0';
	ack_txN0403(0)<='0';
	data_inN0403(1)<=data_outN0303(0);
	rxN0403(1)<=txN0303(0);
	ack_txN0403(1)<=ack_rxN0303(0);
	data_inN0403(2)<=data_outN0402(3);
	rxN0403(2)<=txN0402(3);
	ack_txN0403(2)<=ack_rxN0402(3);
	data_inN0403(3)<=data_outN0404(2);
	rxN0403(3)<=txN0404(2);
	ack_txN0403(3)<=ack_rxN0404(2);
	data_inN0403(4)<=data_inLocal(N0403);
	rxN0403(4)<=rxLocal(N0403);
	ack_txN0403(4)<=ack_txLocal(N0403);
	ack_rxLocal(N0403)<=ack_rxN0403(4);
	data_outLocal(N0403)<=data_outN0403(4);
	txLocal(N0403)<=txN0403(4);

	-- entradas do roteador0004
	data_inN0004(0)<=data_outN0104(1);
	rxN0004(0)<=txN0104(1);
	ack_txN0004(0)<=ack_rxN0104(1);
	data_inN0004(1)<=(others=>'0');
	rxN0004(1)<='0';
	ack_txN0004(1)<='0';
	data_inN0004(2)<=data_outN0003(3);
	rxN0004(2)<=txN0003(3);
	ack_txN0004(2)<=ack_rxN0003(3);
	data_inN0004(3)<=(others=>'0');
	rxN0004(3)<='0';
	ack_txN0004(3)<='0';
	data_inN0004(4)<=data_inLocal(N0004);
	rxN0004(4)<=rxLocal(N0004);
	ack_txN0004(4)<=ack_txLocal(N0004);
	ack_rxLocal(N0004)<=ack_rxN0004(4);
	data_outLocal(N0004)<=data_outN0004(4);
	txLocal(N0004)<=txN0004(4);

	-- entradas do roteador0104
	data_inN0104(0)<=data_outN0204(1);
	rxN0104(0)<=txN0204(1);
	ack_txN0104(0)<=ack_rxN0204(1);
	data_inN0104(1)<=data_outN0004(0);
	rxN0104(1)<=txN0004(0);
	ack_txN0104(1)<=ack_rxN0004(0);
	data_inN0104(2)<=data_outN0103(3);
	rxN0104(2)<=txN0103(3);
	ack_txN0104(2)<=ack_rxN0103(3);
	data_inN0104(3)<=(others=>'0');
	rxN0104(3)<='0';
	ack_txN0104(3)<='0';
	data_inN0104(4)<=data_inLocal(N0104);
	rxN0104(4)<=rxLocal(N0104);
	ack_txN0104(4)<=ack_txLocal(N0104);
	ack_rxLocal(N0104)<=ack_rxN0104(4);
	data_outLocal(N0104)<=data_outN0104(4);
	txLocal(N0104)<=txN0104(4);

	-- entradas do roteador0204
	data_inN0204(0)<=data_outN0304(1);
	rxN0204(0)<=txN0304(1);
	ack_txN0204(0)<=ack_rxN0304(1);
	data_inN0204(1)<=data_outN0104(0);
	rxN0204(1)<=txN0104(0);
	ack_txN0204(1)<=ack_rxN0104(0);
	data_inN0204(2)<=data_outN0203(3);
	rxN0204(2)<=txN0203(3);
	ack_txN0204(2)<=ack_rxN0203(3);
	data_inN0204(3)<=(others=>'0');
	rxN0204(3)<='0';
	ack_txN0204(3)<='0';
	data_inN0204(4)<=data_inLocal(N0204);
	rxN0204(4)<=rxLocal(N0204);
	ack_txN0204(4)<=ack_txLocal(N0204);
	ack_rxLocal(N0204)<=ack_rxN0204(4);
	data_outLocal(N0204)<=data_outN0204(4);
	txLocal(N0204)<=txN0204(4);

	-- entradas do roteador0304
	data_inN0304(0)<=data_outN0404(1);
	rxN0304(0)<=txN0404(1);
	ack_txN0304(0)<=ack_rxN0404(1);
	data_inN0304(1)<=data_outN0204(0);
	rxN0304(1)<=txN0204(0);
	ack_txN0304(1)<=ack_rxN0204(0);
	data_inN0304(2)<=data_outN0303(3);
	rxN0304(2)<=txN0303(3);
	ack_txN0304(2)<=ack_rxN0303(3);
	data_inN0304(3)<=(others=>'0');
	rxN0304(3)<='0';
	ack_txN0304(3)<='0';
	data_inN0304(4)<=data_inLocal(N0304);
	rxN0304(4)<=rxLocal(N0304);
	ack_txN0304(4)<=ack_txLocal(N0304);
	ack_rxLocal(N0304)<=ack_rxN0304(4);
	data_outLocal(N0304)<=data_outN0304(4);
	txLocal(N0304)<=txN0304(4);

	-- entradas do roteador0404
	data_inN0404(0)<=(others=>'0');
	rxN0404(0)<='0';
	ack_txN0404(0)<='0';
	data_inN0404(1)<=data_outN0304(0);
	rxN0404(1)<=txN0304(0);
	ack_txN0404(1)<=ack_rxN0304(0);
	data_inN0404(2)<=data_outN0403(3);
	rxN0404(2)<=txN0403(3);
	ack_txN0404(2)<=ack_rxN0403(3);
	data_inN0404(3)<=(others=>'0');
	rxN0404(3)<='0';
	ack_txN0404(3)<='0';
	data_inN0404(4)<=data_inLocal(N0404);
	rxN0404(4)<=rxLocal(N0404);
	ack_txN0404(4)<=ack_txLocal(N0404);
	ack_rxLocal(N0404)<=ack_rxN0404(4);
	data_outLocal(N0404)<=data_outN0404(4);
	txLocal(N0404)<=txN0404(4);

end NOC;